#!/usr/bin/env node

const { execSync } = require('child_process');
const path = require('path');
const fs = require('fs');


if (process.argv.length < 3) {
    console.log('You have to provide a name to your app.');
    console.log('For example :');
    console.log('    npx create-my-boilerplate my-app');
    process.exit(1);
}

const projectName = process.argv[2];
const currentPath = process.cwd();
const projectPath = path.join(currentPath, projectName);
const git_repo = 'https://github.com/aadarshbabu/create-express-app'

try {
    fs.mkdirSync(projectPath);
} catch (err) {
    if (err.code === 'EEXIST') {
        console.log(`The file ${projectName} already exist in the current directory, please give it another name.`);
    } else {
        console.log(error);
    }
    process.exit(1);
}


async function main() {

    try {
        console.log('Downloading files...');
        execSync(`git clone --depth 1 ${git_repo} ${projectPath}`);

        process.chdir(projectPath);

        console.log('Installing dependencies...');
        const stdout = execSync('npm install');
        console.log(stdout.toString());

        // console.log('Removing useless files');
        fs.rmSync(path.join(projectPath, '.git'), { recursive: true });

        console.log(`Success! Create express app with ${projectPath}`);
        console.log(`Inside this directory you can run several command: `);

        console.log(`
        `)
        console.log("\x1b[34m", ` npm start `);
        console.log("\x1b[0m", "    Start the devlopment Server. ");
        console.log(`
        `)
        console.log("\x1b[34m", ` npm run build `);
        console.log("\x1b[0m", "    Bundal the application into static file for producation. ");
        console.log(`
        `)
        console.log("\x1b[34m", ` npm run dev `);
        console.log("\x1b[0m", "    Start Express server in devlopment mode. ");
        console.log(`
        `)
        console.log("\x1b[34m", ` npm run test `);
        console.log("\x1b[0m", "    Starts the test runner. ");
        console.log(`
        `)

        console.log(`We suggest that you begin to typing:`);
        console.log(`
        `)
        console.log("\x1b[34m", `cd`, "\x1b[0m", `${projectName}`);
        console.log("\x1b[34m", `npm start`);

    } catch (error) {
        console.log(error);
    }

}
main();